Option Explicit
'Author:  Dave Newbern, dave@newbern.org

Const ConnectionString = "Driver={SQLite3 ODBC Driver};Database=C:\Program Files\Spiceworks\db\spiceworks_prod.db"  

Dim html, c_warranty
Dim supportDate, shipDate
Dim httpObjectName 
Dim WinDir
Dim OSType
Dim AnomalyReport
Dim AppPath:AppPath = Replace(WScript.ScriptFullName, WScript.ScriptName, "")
Dim wshShell: Set WshShell = CreateObject("WScript.Shell") 

'Enumerate a few system variables
OSType = WshShell.RegRead("HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment\PROCESSOR_ARCHITECTURE")
WinDir = WshShell.ExpandEnvironmentStrings("%windir%") 

'Ensure we're calling with cscript.exe.  
If lCase(Right(WScript.Fullname, 11)) <> "cscript.exe" Then WshShell.Run Windir & "\system32\CSCRIPT.EXE /nologo " & WScript.ScriptFullName


'Ensure the required custom fields exist in the database
CreateField "devices","c_product_number","varchar(20)"



GetHPProductNumber



wscript.quit







Sub GetHPProductNumber()
	Dim DB, RS
	Dim SQL 
	Dim httpRequest
	Dim serial_number

	Set DB = CreateObject("ADODB.Connection") 
	DB.ConnectionString = ConnectionString    
	DB.Open   
	
	Set RS = CreateObject("ADODB.Recordset")    
	RS.open "SELECT * FROM devices WHERE type like 'computer'", DB, 3,3   
	
	While Not rs.eof

		If lcase(rs("manufacturer")) = "hewlett-packard" And clean(rs("c_product_number")) = "" Then
			AddToLog "HP found: " & rs("name")	

			if IsValidPing(rs("name")) Then
				Dim objWMIService,colItems,objItem,system_pn
	
				Set objWMIService = GetObject("winmgmts:\\" & rs("name") & "\root\CIMV2")
				Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem",,48)
				For Each objItem in colItems
					On Error Resume Next
					If Not objItem.OEMStringArray = Null Then system_PN=trim(join(objItem.OEMStringArray))
					On Error goto 0
					AddToLog "     Model: " & objItem.model
				Next
				
				If instr(system_pn,"Product ID: ") Then system_pn = trim(mid(system_pn,12))
				AddToLog "     Product: " & system_PN
					
				If mid(system_pn,7,1) = "-" Then
					AddToLog "     Updating record"
					DB.Execute ("UPDATE devices SET c_product_number='" & system_pn & "' WHERE ID=" & rs("id"))
				End If
			  Else
			  	AddToLog("Can not ping system")
			End If
		
		End If
	
		rs.movenext
	Wend
	
	Set RS = Nothing   
	Set DB = Nothing   
End Sub	
	
	






Function clean(str)
	'Clean effectively strips off Nulls, making it easier to compare results from a database
	clean = trim(str & " ")
End Function



Sub AddToLog(textToLog)
	Dim fs, Logfile
	Set fs = CreateObject("Scripting.FileSystemObject") 

	Set Logfile = fs.OpenTextFile("log.txt", 8, True, 0)  
	Logfile.writeline textToLog
	Set Logfile = Nothing 

	wscript.echo textToLog
End Sub


Function CreateField(tableName, columnName, columnType)
	Dim DB, RS
	Dim SQL 
	
	Set DB = CreateObject("ADODB.Connection") 
	DB.ConnectionString = ConnectionString    
	DB.Open   
	
	Set RS = CreateObject("ADODB.Recordset")    
	On Error Resume Next
	RS.open "SELECT " & columnName & " FROM " & tableName, DB, 3,3   

	If err.number <> 0 Then
		wscript.echo "Creating column " & tablename & "." & columnName
		err.clear
		DB.Execute ("ALTER TABLE " & tablename & " ADD COLUMN " & columnName & " " & columnType)
	End If
	On Error goto 0	
	
	Set RS = Nothing   
	Set DB = Nothing   
End Function



function IsValidPing(byval vsIpAddress)
  dim objFSO, objShell, objTempFile, objTS
  dim sCommand, sReadLine
  dim bReturn

  '* Create objects.
  set objShell = WScript.CreateObject("Wscript.Shell")
  set objFSO = CreateObject("Scripting.FileSystemObject")

  '* Set default return value.
  bReturn = false

  '* Create command line to ping and save results to a temp file.
  sCommand = "cmd /c ping -n 2 -w 1000 " & vsIpAddress & " > temp.txt"

  '* Execute the command.
  objShell.run sCommand, 0, true

  '* Get the temp file.
  set objTempFile = objFSO.GetFile("temp.txt")
  set objTS = objTempFile.OpenAsTextStream(1)

  '* Loop through the temp file to see if ping was successful.
  do while objTs.AtEndOfStream <> true
    sReadLine = objTs.ReadLine
    '* if "reply from" is found in temp file then ping was successful.
    if instr(lcase(sReadLine), "reply from") > 0 then
      bReturn = true
      exit do
    end if
  loop

  '* Close temp file and release objects.
  objTS.close
  objTempFile.delete
  set objTS = nothing
  set objTempFile = nothing
  set objShell = nothing
  set objFSO = nothing

  '* Return value.
  IsValidPing = bReturn

end function

